Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# VirtualFile Class Reference

The abstract base class for a file or directory within the VirtualFileSystem. More...

Inheritance diagram for VirtualFile:

List of all members.

## Public Member Functions
| closeReadFile (istream stream)
| Closes a file opened by a previous call to open_read_file().
| closeReadWriteFile (iostream stream)
| Closes a file opened by a previous call to open_read_write_file().
| closeWriteFile (ostream stream)
| Closes a file opened by a previous call to open_write_file().
bool | copyFile (VirtualFile new_file)
| Attempts to copy the contents of this file to the indicated file.
bool | deleteFile ()
| Attempts to delete this file or directory.
Filename | getFilename ()
int | getFileSize ()
| Returns the current size on disk (or wherever it is) of the file before it has been opened.
int | getFileSize (istream stream)
| Returns the current size on disk (or wherever it is) of the already-open file.
VirtualFileSystem | getFileSystem ()
Filename const | getOriginalFilename ()
| Returns the original filename as it was used to locate this VirtualFile.
bool | getSystemInfo (SubfileInfo info)
| Populates the SubfileInfo structure with the data representing where the file actually resides on disk, if this is knowable.
unsigned int | getTimestamp ()
| Returns a time_t value that represents the time the file was last modified, to within whatever precision the operating system records this information (on a Windows95 system, for instance, this may only be accurate to within 2 seconds).
bool | hasFile ()
| Returns true if this file exists, false otherwise.
bool | isDirectory ()
| Returns true if this file represents a directory (and scan_directory() may be called), false otherwise.
bool | isRegularFile ()
| Returns true if this file represents a regular file (and read_file() may be called), false otherwise.
bool | isWritable ()
| Returns true if this file may be written to, which implies write_file() may be called (unless it is a directory instead of a regular file).
| ls (ostream out)
| If the file represents a directory, lists its contents.
| ls ()
| If the file represents a directory, lists its contents.
| lsAll ()
| If the file represents a directory, recursively lists its contents and those of all subdirectories.
| lsAll (ostream out)
| If the file represents a directory, recursively lists its contents and those of all subdirectories.
ostream | openAppendFile ()
| Works like open_write_file(), but the file is opened in append mode.
iostream | openReadAppendFile ()
| Works like open_read_write_file(), but the file is opened in append mode.
istream | openReadFile (bool auto_unwrap)
| Opens the file for reading.
iostream | openReadWriteFile (bool truncate)
| Opens the file for writing.
ostream | openWriteFile (bool auto_wrap, bool truncate)
| Opens the file for writing.
| output (ostream out)
string | readFile (bool auto_unwrap)
| Returns the entire contents of the file as a string.
bool | renameFile (VirtualFile new_file)
| Attempts to move or rename this file or directory.
VirtualFileList | scanDirectory ()
| If the file represents a directory (that is, is_directory() returns true), this returns the list of files within the directory at the current time.
bool | wasReadSuccessful ()
| Call this method after a reading the istream returned by open_read_file() to completion.
bool | writeFile (string data, bool auto_wrap)
| Writes the entire contents of the file as a string, if it is writable.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

The abstract base class for a file or directory within the VirtualFileSystem.

## Member Function Documentation

closeReadFile | ( | istream | stream | ) |

Closes a file opened by a previous call to open_read_file().

This really just deletes the istream pointer, but it is recommended to use this interface instead of deleting it explicitly, to help work around compiler issues.

closeReadWriteFile | ( | iostream | stream | ) |

Closes a file opened by a previous call to open_read_write_file().

This really just deletes the iostream pointer, but it is recommended to use this interface instead of deleting it explicitly, to help work around compiler issues.

closeWriteFile | ( | ostream | stream | ) |

Closes a file opened by a previous call to open_write_file().

This really just deletes the ostream pointer, but it is recommended to use this interface instead of deleting it explicitly, to help work around compiler issues.

bool copyFile | ( | VirtualFile | new_file | ) |

Attempts to copy the contents of this file to the indicated file.

Returns true on success, false on failure.

bool deleteFile | ( |  | ) |

Attempts to delete this file or directory.

This can remove a single file or an empty directory. It will not remove a nonempty directory. Returns true on success, false on failure.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TypedReferenceCount.

Reimplemented in VirtualFileComposite, VirtualFileSimple, and VirtualFileHTTP.

Filename getFilename | ( |  | ) |

int getFileSize | ( |  | ) |

Returns the current size on disk (or wherever it is) of the file before it has been opened.

int getFileSize | ( | istream | stream | ) |

Returns the current size on disk (or wherever it is) of the already-open file.

Pass in the stream that was returned by open_read_file(); some implementations may require this stream to determine the size.

VirtualFileSystem getFileSystem | ( |  | ) |

Filename const getOriginalFilename | ( |  | ) |

Returns the original filename as it was used to locate this VirtualFile.

This is usually, but not always, the same string returned by get_filename().

bool getSystemInfo | ( | SubfileInfo | info | ) |

Populates the SubfileInfo structure with the data representing where the file actually resides on disk, if this is knowable.

Returns true if the file might reside on disk, and the info is populated, or false if it does not (or it is not known where the file resides), in which case the info is meaningless.

unsigned int getTimestamp | ( |  | ) |

Returns a time_t value that represents the time the file was last modified, to within whatever precision the operating system records this information (on a Windows95 system, for instance, this may only be accurate to within 2 seconds).

If the timestamp cannot be determined, either because it is not supported by the operating system or because there is some error (such as file not found), returns 0.

bool hasFile | ( |  | ) |

Returns true if this file exists, false otherwise.

bool isDirectory | ( |  | ) |

Returns true if this file represents a directory (and scan_directory() may be called), false otherwise.

bool isRegularFile | ( |  | ) |

Returns true if this file represents a regular file (and read_file() may be called), false otherwise.

bool isWritable | ( |  | ) |

Returns true if this file may be written to, which implies write_file() may be called (unless it is a directory instead of a regular file).

ls | ( |  | ) |

If the file represents a directory, lists its contents.

ls | ( | ostream | out | ) |

If the file represents a directory, lists its contents.

lsAll | ( |  | ) |

If the file represents a directory, recursively lists its contents and those of all subdirectories.

lsAll | ( | ostream | out | ) |

If the file represents a directory, recursively lists its contents and those of all subdirectories.

ostream openAppendFile | ( |  | ) |

Works like open_write_file(), but the file is opened in append mode.

Like open_write_file, the returned pointer should eventually be passed to close_write_file().

iostream openReadAppendFile | ( |  | ) |

Works like open_read_write_file(), but the file is opened in append mode.

Like open_read_write_file, the returned pointer should eventually be passed to close_read_write_file().

istream openReadFile | ( | bool | auto_unwrap | ) |

Opens the file for reading.

Returns a newly allocated istream on success (which you should eventually delete when you are done reading). Returns NULL on failure.

iostream openReadWriteFile | ( | bool | truncate | ) |

Opens the file for writing.

Returns a newly allocated iostream on success (which you should eventually delete when you are done writing). Returns NULL on failure.

ostream openWriteFile | ( | bool | auto_wrap,
|  | bool | truncate
| ) |  |

Opens the file for writing.

Returns a newly allocated ostream on success (which you should eventually delete when you are done writing). Returns NULL on failure.

output | ( | ostream | out | ) |

string readFile | ( | bool | auto_unwrap | ) |

Returns the entire contents of the file as a string.

bool renameFile | ( | VirtualFile | new_file | ) |

Attempts to move or rename this file or directory.

If the original file is an ordinary file, it will quietly replace any already-existing file in the new filename (but not a directory). If the original file is a directory, the new filename must not already exist.

If the file is a directory, the new filename must be within the same mount point. If the file is an ordinary file, the new filename may be anywhere; but if it is not within the same mount point then the rename operation is automatically performed as a two-step copy-and-delete operation.

VirtualFileList scanDirectory | ( |  | ) |

If the file represents a directory (that is, is_directory() returns true), this returns the list of files within the directory at the current time.

Returns NULL if the file is not a directory or if the directory cannot be read.

bool wasReadSuccessful | ( |  | ) |

Call this method after a reading the istream returned by open_read_file() to completion.

If it returns true, the file was read completely and without error; if it returns false, there may have been some errors or a truncated file read. This is particularly likely if the stream is a VirtualFileHTTP.

bool writeFile | ( | string | data,
|  | bool | auto_wrap
| ) |  |

Writes the entire contents of the file as a string, if it is writable.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties